package gfe;


import org.eclipse.emf.common.EMFPlugin;
import org.eclipse.emf.common.util.ResourceLocator;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
//import org.osgi.framework.BundleContext;
import java.util.*;

/**
 * The main plugin class to be used in the desktop.
 */

public class GfePlugin extends EMFPlugin implements BundleActivator {
	boolean DEBUG = true;  // true for console output
	//The shared instance.
	private static GfePlugin plugin;
	//Resource bundle.
	private ResourceBundle resourceBundle;
	
	/**
	 * The constructor.
	 */
	public GfePlugin() {
		//super();
		super
		  (new ResourceLocator [] {
		   });
		plugin = this;
		try {
			//resourceBundle = ResourceBundle.getBundle("gfe.GfePluginResources");
			resourceBundle = ResourceBundle.getBundle("gfe.gfe.GfePluginResources");
			if (DEBUG) System.out.println("found resource bundle: "+ getResourceString("_UI_properties_file"));
		} catch (MissingResourceException x) {
			resourceBundle = null;
			if (DEBUG) System.out.println("resource bundle error: "+ x.getMessage());
		}
	}

	/**
	 * bundles not emf friendly yet ?
	 * 
	 * This method is called upon plug-in activation
	 */
	public void start(BundleContext context) throws Exception {
		//super.start(context);
	}

	/**
	 * This method is called when the plug-in is stopped
	 */
	public void stop(BundleContext context) throws Exception {
		//super.stop(context);
	}

	
	/**
	 * Returns the shared instance.
	 */
	public static GfePlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the string from the plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString(String key) {
		ResourceBundle bundle = GfePlugin.getDefault().getResourceBundle();
		try {
			return (bundle != null) ? bundle.getString(key) : key;
		} catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.emf.common.EMFPlugin#getPluginResourceLocator()
	 */
	public ResourceLocator getPluginResourceLocator() {
		return plugin;
	}
}
